# Endpoints

A brief overview of the functionality and concepts.

## [Documents](/mspro.services/endpoints/documents.md)

The **Document** endpoint `/docs`  allows you to manage data in the form of documents, often using a format like JSON, TXT, or XML. It is a **schema-less data storage**, which is useful for applications that need to "park" data for some time, like status', or  information which is required only for the life-time of a business or an import process, for example.

[Open API Description](https://msproservices.azurewebsites.net/#tag/docs)

## [Render Engine](/mspro.services/endpoints/render-engine.md)

The **Template & Render Engine** endpoint `/templates` is a powerful **reporting engine, based on Apache's** [**FreeMarker**](https://freemarker.apache.org/). Especially with Boomi Integration this endpoint can solve many requirements quickly:

* Render formatted E-Mails with information from the current process.
* Create HTML templates with placeholders and \
  fill the out using data from the process.
  * Create (signed) PDF documents from the rendered HTML.\
    (Required additional libraries.)&#x20;
* Turn your process data into any kind of "readable" document:
  * Print invoices
  * Create order forms
  * ...

In combination with Documents where you can store the rendered document, this is the perfect fit!

## [The Mirror](/mspro.services/endpoints/the-mirror.md)

The **Mirror** `/mirror` endpoint does not have much functionality: It simply responds what you requested, and it logs the request incl. header and body as a *Document* - for a couple of minutes.

The intention was to visualize what your service client is sending if you do not have too much control over the client.&#x20;

With Boomi Integration, for example, you cannot visualize what you are sending. If you receive weird responses, you may want to redirect your Boomi request to the Mirror endpoint to see what you sent.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://services.markusschmidt.pro/mspro.services/endpoints.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
